每日一题 2369

2369. 检查数组是否存在有效划分

题目描述:

给你一个下标从 0 开始的整数数组 nums ,你必须将数组划分为一个或多个 连续 子数组。

如果获得的这些子数组中每个都能满足下述条件之一 ,则可以称其为数组的一种 有效 划分:

  1. 子数组 恰 由 2 个相等元素组成,例如,子数组 [2,2] 。
  2. 子数组 恰 由 3 个相等元素组成,例如,子数组 [4,4,4] 。
  3. 子数组 恰 由 3 个连续递增元素组成,并且相邻元素之间的差值为 1 。例如,子数组 [3,4,5] ,但是子数组 [1,3,5] 不符合要求。

如果数组 至少 存在一种有效划分,返回 true,否则,返回 false 。

示例 1:

复制代码
输入:nums = [4,4,4,5,6]
输出:true
解释:数组可以划分成子数组 [4,4] 和 [4,5,6] 。
这是一种有效划分,所以返回 true 。

示例 2:

复制代码
输入:nums = [1,1,1,2]
输出:false
解释:该数组不存在有效划分。

提示:

  • 2 <= nums.length <= 10^5
  • 1 <= nums[i] <= 10^6

思路:

感觉子串的题很多都是滑动窗口?

这一二条有重合的部分,想象如果满足二必定满足一,所以只需要判断一是否满足,如果是,则直接跳出;不满足一也不可能满足二,直接不用判断条件二了;一判断结束,开始判断三。

没试出来,直奔题解,哦,dp

代码:

复制代码
class Solution {
    public boolean validPartition(int[] nums) {
        int n =nums.length;
        boolean[] f=new boolean[n+1];
        f[0]=true;
        for(int i=1;i<n;i++){
            if (f[i - 1] && nums[i] == nums[i - 1] ||
                i > 1 && f[i - 2] && (nums[i] == nums[i - 1] && nums[i] == nums[i - 2] ||
                                      nums[i] == nums[i - 1] + 1 && nums[i] == nums[i - 2] + 2)) {
                f[i + 1] = true;
                }
        }
        return f[n];
    }
}
相关推荐
weixin_307779138 分钟前
C++代码实现MATLAB中的normalize函数功能
开发语言·c++·算法·matlab
不会就选b21 分钟前
算法日常・每日刷题--<动态规划>11
算法
(Charon)23 分钟前
【C++面试】手写String类:同时实现拷贝构造与移动构造
c++·算法
迷途之人不知返42 分钟前
算法系列6:模拟
算法
旺仔仔仔1 小时前
# 机器人项目实战(1):选相机、试深度,再到手眼标定
算法
CoderYanger1 小时前
A.每日一题:1614. 括号的最大嵌套深度
java·程序人生·算法·leetcode·面试·学习方法
yuki蜜语1 小时前
别只会调包跑模型!一文讲透大模型训练底层的“递推、递归、三明治”三重逻辑
算法
成旭先生1 小时前
银行卡识别 API:一张照片读出卡号、BIN 与发卡行
人工智能·算法·ocr·api接口·金融科技·银行卡识别·支付风控
陌上花开缓缓归以2 小时前
mebdlts3.4.1安全启动全流程
服务器·算法
Nebula_g2 小时前
JavaSE拓展:可变参数
java·开发语言·算法·安全·javase·可变参数